/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahl.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="WAHLDURCHFUEHRUNG.UK",
     query="SELECT o FROM Wahldurchfuehrung o WHERE "

                         + "o"
                +".wahlart"
                +".name"
              +" = ?1"

             +" AND "         + "o"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?2"

             +" AND "         + "o"
                +".wahltermin"
                +".nummer"
              +" = ?3"

             +" AND "         + "o"
                +".wahltermin"
                +".wahldatum"
              +" = ?4"

             +" AND "         + "o"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?5"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="WAHLDURCHFUEHRUNG.All",
     query="SELECT o FROM Wahldurchfuehrung o WHERE o.wahltermin.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLDURCHFUEHRUNG.Name",
     query="SELECT OBJECT(o) FROM Wahldurchfuehrung o WHERE o.wahltermin.mandant=?1 AND o.name=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLDURCHFUEHRUNG")
@javax.persistence.Cacheable
@javax.persistence.PrimaryKeyJoinColumn(name="wahl_id")
@javax.persistence.DiscriminatorValue(Wahldurchfuehrung.DISCRIMINATOR_VALUE)

public
 class Wahldurchfuehrung
extends AbstractWahldurchfuehrung
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "WAHLDURCHFUEHRUNG";

  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Wahldurchfuehrung() {
    super();
  }
    public Wahldurchfuehrung(de.ivu.elect.jee.entity.customdata.CustomData customData){
        super(customData);
      }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Wahldurchfuehrung(Wahldurchfuehrung original){
      original.copyEntity(this);
    }


  @Override
  public void resetAttributeChanged() {
        hasChangedErgebniseingangsart = false;
          hasChangedSitzberechnungsalgorithmus = false;
  



    super.resetAttributeChanged();
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNISEINGANGSART", nullable = WahldurchfuehrungConstants.ERGEBNISEINGANGSART_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart =  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart.VORLAEUFIG;

  @javax.persistence.Transient
  protected boolean hasChangedErgebniseingangsart = false;

  public boolean hasChangedErgebniseingangsart(){
    return hasChangedErgebniseingangsart;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErgebniseingangsart = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart wertNachLadenErgebniseingangsart;
  
  /**
   * 
   *
   * getter for WAHLDURCHFUEHRUNG.ERGEBNISEINGANGSART
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart getErgebniseingangsart() {
        return ergebniseingangsart;
      }

  /**
   * 
   *
   * setter for WAHLDURCHFUEHRUNG.ERGEBNISEINGANGSART
   *
   * @param ergebniseingangsart
   */
  @Override   public void setErgebniseingangsart( de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsart) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart ergebniseingangsartInternal = ergebniseingangsart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebniseingangsart
      , ergebniseingangsartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebniseingangsart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebniseingangsart");
      }


             if (!isSeitLadenVeraendertErgebniseingangsart) {
          isSeitLadenVeraendertErgebniseingangsart = thisAttributChanged;
         if (isSeitLadenVeraendertErgebniseingangsart){
           wertNachLadenErgebniseingangsart=this.ergebniseingangsart;
         }
       }
      

       this.ergebniseingangsart = ergebniseingangsartInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "SITZBERECHNUNGSALGORITHMUS", nullable = WahldurchfuehrungConstants.SITZBERECHNUNGSALGORITHMUS_NULLABLE)
    
  protected de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus sitzberechnungsalgorithmus =  de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus.KEIN;

  @javax.persistence.Transient
  protected boolean hasChangedSitzberechnungsalgorithmus = false;

  public boolean hasChangedSitzberechnungsalgorithmus(){
    return hasChangedSitzberechnungsalgorithmus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSitzberechnungsalgorithmus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus wertNachLadenSitzberechnungsalgorithmus;
  
  /**
   * 
   *
   * getter for WAHLDURCHFUEHRUNG.SITZBERECHNUNGSALGORITHMUS
   */
    @Override   public  de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus getSitzberechnungsalgorithmus() {
        return sitzberechnungsalgorithmus;
      }

  /**
   * 
   *
   * setter for WAHLDURCHFUEHRUNG.SITZBERECHNUNGSALGORITHMUS
   *
   * @param sitzberechnungsalgorithmus
   */
  @Override   public void setSitzberechnungsalgorithmus( de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus sitzberechnungsalgorithmus) {

       resetTkCache();
                  de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus sitzberechnungsalgorithmusInternal = sitzberechnungsalgorithmus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.sitzberechnungsalgorithmus
      , sitzberechnungsalgorithmusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSitzberechnungsalgorithmus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("sitzberechnungsalgorithmus");
      }


             if (!isSeitLadenVeraendertSitzberechnungsalgorithmus) {
          isSeitLadenVeraendertSitzberechnungsalgorithmus = thisAttributChanged;
         if (isSeitLadenVeraendertSitzberechnungsalgorithmus){
           wertNachLadenSitzberechnungsalgorithmus=this.sitzberechnungsalgorithmus;
         }
       }
      

       this.sitzberechnungsalgorithmus = sitzberechnungsalgorithmusInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Wahldurchfuehrung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Wahldurchfuehrung other){
        super.copyEntity(other);
                             other.ergebniseingangsart = this.ergebniseingangsart;
                                other.sitzberechnungsalgorithmus = this.sitzberechnungsalgorithmus;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Wahldurchfuehrung.class)){
        copyEntityAttributesUsingSetter((Wahldurchfuehrung) other.castTo(Wahldurchfuehrung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Wahldurchfuehrung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Wahldurchfuehrung other){
      super.copyEntityAttributesUsingSetter(other);
               other.setErgebniseingangsart(this.ergebniseingangsart);
                  other.setSitzberechnungsalgorithmus(this.sitzberechnungsalgorithmus);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }

    @Override
    public void copyEntityAttributesUsingSetter(de.ivu.elect.business.wahl.entity.Wahl other){
       if (other.isInstanceOf(Wahldurchfuehrung.class)) {
         copyEntityAttributesUsingSetter(other.castTo(Wahldurchfuehrung.class).getEntity());
       } else {
         super.copyEntityAttributesUsingSetter(other);
       }
    }

  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Wahldurchfuehrung other){
       super.copyChangedEntityAttributesUsingSetter(other);
                       if (hasChangedErgebniseingangsart) {
        other.setErgebniseingangsart(this.ergebniseingangsart);
      }
                             if (hasChangedSitzberechnungsalgorithmus) {
        other.setSitzberechnungsalgorithmus(this.sitzberechnungsalgorithmus);
      }
             }

    @Override
    public void copyChangedEntityAttributesUsingSetter(de.ivu.elect.business.wahl.entity.Wahl other){
      if (other.isInstanceOf(Wahldurchfuehrung.class)) {
        copyChangedEntityAttributesUsingSetter(other.castTo(Wahldurchfuehrung.class).getEntity());
      } else {
        super.copyChangedEntityAttributesUsingSetter(other);
      }
    }




    @javax.persistence.Transient
    private transient WahldurchfuehrungTK tkCache;

    @Override
    protected void resetTkCache() {
    super.resetTkCache();
        tkCache = null;
    }

    public WahldurchfuehrungTK getWahldurchfuehrungTK(){
    if (tkCache==null) {
    tkCache = new WahldurchfuehrungTK(

  (getWahlart() == null) ? null : getWahlart().getWahlartTK()
,   (getWahltermin() == null) ? null : getWahltermin().getWahlterminTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahldurchfuehrungTK();
    }

  @Override
  public WahldurchfuehrungUK getUk(){
    return getWahldurchfuehrungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Wahldurchfuehrung.class;
  }

public WahldurchfuehrungUK getWahldurchfuehrungUK(){

   return  new WahldurchfuehrungUK(

    getWahlart()==null?null:getWahlart().getWahlartUK()
,     getWahltermin()==null?null:getWahltermin().getWahlterminUK()


  );
}

  @javax.persistence.Transient
  private transient WahldurchfuehrungProperties properties;

  @Override
  public WahldurchfuehrungProperties getProperties(){
    if (properties == null) {
      properties = new WahldurchfuehrungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahldurchfuehrungProperties getWahldurchfuehrungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahldurchfuehrungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
        if (super.isAenderungenProtokollieren()){
      return true;
    }
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
            super.setProtokollierteAttributeMitWerten(werteVorher);
     
      if (werteVorher.containsKey(WahldurchfuehrungConstants.MESSAGE_KEY_ERGEBNISEINGANGSART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahldurchfuehrungConstants.MESSAGE_KEY_ERGEBNISEINGANGSART_EINZAHL);

        ergebniseingangsart =
     (de.ivu.elect.business.stimmeingabe.entity.Ergebniseingangsart) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahldurchfuehrungConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahldurchfuehrungConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL);

        sitzberechnungsalgorithmus =
     (de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = super.getProtokollierteAttributeMitWerten();
                        if (isSeitLadenVeraendertErgebniseingangsart) {
      result.put(WahldurchfuehrungConstants.MESSAGE_KEY_ERGEBNISEINGANGSART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenErgebniseingangsart , ergebniseingangsart));
    }
                            if (isSeitLadenVeraendertSitzberechnungsalgorithmus) {
      result.put(WahldurchfuehrungConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenSitzberechnungsalgorithmus , sitzberechnungsalgorithmus));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
        super.resetProtokollierteAttribute();
                      isSeitLadenVeraendertErgebniseingangsart = false;
      wertNachLadenErgebniseingangsart = null;
                          isSeitLadenVeraendertSitzberechnungsalgorithmus = false;
      wertNachLadenSitzberechnungsalgorithmus = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
           java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = super.getFachlichAbhaengigeEntitaeten();
            return result;
  }

        
            @Override
            protected String getInitialDiscriminator() {
              return "WAHLDURCHFUEHRUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  @Override
  public boolean isPersistent() {
    return getId() != null;
  }



            
                  @Override
                public void resetValidation() {
                  super.resetValidation();
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                          @Override
                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                  validationResult.addAll(super.validateEntity());
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebniseingangsart, this, WahldurchfuehrungConstants.MESSAGE_KEY_ERGEBNISEINGANGSART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(sitzberechnungsalgorithmus, this, WahldurchfuehrungConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            }
